StartTest(function(t) {
    
    t.plan(6)
    
	//==================================================================================================================================================================================
    t.diag("Test.Run.Test creation")
    
    var test = new Test.Run.Test({
    	
    	harness : Test.Run.Harness.my,
    	
    	run : function (t) {
    		t.plan(4)
    		
    		t.diag('Diag message')
    		
    		t.pass('Pass description')
    		t.fail('Fail description')
    		
    		t.ok(true, 'True is ok')
    		t.is(null, undefined, 'Null is undefined')
    	}
    })
    
    t.ok(test, 'Test object was created')
    
    
    //==================================================================================================================================================================================
    t.diag("Test.Run.Test run")
    
    test.start()
    
    t.ok(test.assertPlanned == 4, 'Plan was setuped')
    
    t.ok(test.results.length == 5, 'Results were created')
    t.ok(test.currentResult == 4, 'Current index is correct')
    t.ok(test.diagCount == 1, 'There was 1 diagnostic message')
    t.ok(test.assertCount == 4, 'There was 4 assertions')
    
    t.ok(test.results[0] instanceof Test.Run.Result.Diagnostic, 'Very 1st result is a diagnostic message')
    t.ok(test.results[1] instanceof Test.Run.Result.Assertion, '2nd results is an assertion')
    
    
    //==================================================================================================================================================================================
    t.diag("No plan #1")
    
    var noPlanTest1 = new Test.Run.Test({
    	
    	harness : Test.Run.Harness.my,
    	
    	run : function (t) {
    		t.diag('Diag message')
    	}
    })
    
    noPlanTest1.start()
    
    t.pass('Diagnostic messages do not require plan')
    
    
    //==================================================================================================================================================================================
    t.diag("No plan #2")
    
    var noPlanTest2 = new Test.Run.Test({
    	
    	harness : Test.Run.Harness.my,
    	
    	run : function (t) {
    		t.diag('Diag message')
    		
    		t.pass('no plan')
    	}
    })
    
    noPlanTest2.start()
    
    t.ok(noPlanTest2.failed, 'Missing plan is detecting')
})